/* Single Tile Minigame Base Library
for the BYONDscape Single Tile Minigame Contest (http://www.byondscape.com)

by Shadowdarke (shadowdarke@hotmail.com) April 2004

If you wish to include Single Tile Minigames in your project, please read
the use.dm file.

If you wish to use this library to design Single Tile Minigames for
BYONDscape, please read the design.dm file.

*********************************************************************
Implementation of minigame controls.

Do not alter the following code. To customize your minigame, include
this library and override the /turf/minigame procs for your own
/turf/minigame child.

See demogame.dm in the demo folder for an example.
********************************************************************/
mob
	Bump(O)
		if(istype(O,/turf/minigame) && client)
			// player mob bumped a minigame
			var/turf/minigame/G = O
			G.GameBumped(src)
		else
			return ..()

client
	var/turf/minigame/Game	/* the game object that this client is
								interacting with or null if not playing
								a mini-game. */

	Center()
		if(Game)
			// tell the game that the mob hit the center key
			Game.PlayerInput(mob,0)
		else
			return ..()

	Move(Loc,Dir)
		if(Game)
			// tell the game that the mob input this direction
			Game.PlayerInput(mob,Dir)
		else
			return ..()

	verb
		EscapeKey() // called when the player presses escape.
			set hidden = 1
			var/old_prompt = command_prompt
			command_prompt = ""	// clear the command line
			spawn(2) command_prompt = old_prompt
			if(Game && (alert(src,"Do you want to quit playing [Game]?",\
				"Quit [Game]?","Yes","No")=="Yes"))
				Game.Quit(mob)	// let the game know the player quit
				Game = null

turf/minigame	// all minigames should be of this type
	density = 1
	verb
		instructions()
			// override to provide game instructions.
			set src in view(1)
			set desc = "Read the game instructions."

			usr << "The instruction manual for this game is missing."

	proc
		GameBumped(mob/M)
			// M just bumped into this game
		PlayerInput(mob/M, Dir)
			/* mob just input Dir into this game.
				Dir 0 is the center numpad key. */
		Quit(mob/M)
			// Called when M quit the game by using the esc key.

atom/movable/minigame_piece
	/* Provided as a standard atom for game pieces so that a developer may
		limit their game's verbs from functioning on the game piece. More
		details are provided in the use.dm file. */

